`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/03/23 23:58:15
// Design Name: 
// Module Name: freqdiv
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

`define PAUSE_30 2'b00
`define COUNT_30 2'b01
`define PAUSE_60 2'b10
`define COUNT_60 2'b11
`define ENABLE 1'b1
`define DISABLE 1'b0
`define MODE_30 1'b0
`define MODE_60 1'b1


module fsm(
    count_enable,
    select_mode,
    in,
    clk,
    rst,
    curr_state
);
    output reg count_enable;
    output reg select_mode;
    output curr_state;
    input [1:0] in; 
    input clk, rst;
    
    reg [1:0] init_state;
    reg [1:0] state;
    reg [1:0] next_state;


    always @*
        case (state)
          `PAUSE_30: 
            case (in)
              2'b00:
                begin
                  next_state = `PAUSE_30;
                  count_enable = `DISABLE;
                  select_mode = `MODE_30;
                  init_state = 2'b00;
                end
              2'b01:
                begin
                  next_state = `COUNT_30;
                  count_enable = `ENABLE;
                  select_mode = `MODE_30;
                  init_state = 2'b00;
                end
              2'b10:
                begin
                  next_state = `PAUSE_60;
                  count_enable = `DISABLE;
                  select_mode = `MODE_60;
                  init_state = 2'b00;
                end
              2'b11:
                begin
                  next_state = `COUNT_60;
                  count_enable = `ENABLE;
                  select_mode = `MODE_60;
                  init_state = 2'b00;
                end
              default:
                begin
                next_state = 2'b00;
                count_enable = 1'b0;
                select_mode = 1'b0;
                init_state = 2'b00;
                end
          endcase

          `COUNT_30:
            case (in)
              2'b00:
                begin
                  next_state = `COUNT_30;
                  count_enable = `ENABLE;
                  select_mode = `MODE_30;
                  init_state = 2'b00;
                end
              2'b01:
                begin
                  next_state = `PAUSE_30;
                  count_enable = `DISABLE;
                  select_mode = `MODE_30;
                  init_state = 2'b00;
                end
              2'b10:
                begin
                  next_state = `COUNT_60;
                  count_enable = `ENABLE;
                  select_mode = `MODE_60;
                  init_state = 2'b00;
                end
              2'b11:
                begin
                  next_state = `PAUSE_60;
                  count_enable = `DISABLE;
                  select_mode = `MODE_60;
                  init_state = 2'b00;
                end
              default:
              begin
              next_state = 2'b00;
              count_enable = 1'b0;
              select_mode = 1'b0;
              init_state = 2'b00;
              end
          endcase
          
          `PAUSE_60:
            case (in)
              2'b00:
                begin
                  next_state = `PAUSE_60;
                  count_enable = `DISABLE;
                  select_mode = `MODE_60;
                  init_state = 2'b00;
                end
              2'b01:
                begin
                  next_state = `COUNT_60;
                  count_enable = `ENABLE;
                  select_mode = `MODE_60;
                  init_state = 2'b00;
                end
              2'b10:
                begin
                  next_state = `PAUSE_30;
                  count_enable = `DISABLE;
                  select_mode = `MODE_30;
                  init_state = 2'b00;
                end
              2'b11:
                begin
                  next_state = `COUNT_30;
                  count_enable = `ENABLE;
                  select_mode = `MODE_30;
                  init_state = 2'b00;
                end
              default:
              begin
              next_state = 2'b00;
              count_enable = 1'b0;
              select_mode = 1'b0;
              init_state = 2'b00;
              end
          endcase
          
          `COUNT_60:
            case (in)
              2'b00:
                begin
                  next_state = `COUNT_60;
                  count_enable = `ENABLE;
                  select_mode = `MODE_60;
                  init_state = 2'b00;
                end
              2'b01:
                begin
                  next_state = `PAUSE_60;
                  count_enable = `DISABLE;
                  select_mode = `MODE_60;
                  init_state = 2'b00;
                end
              2'b10:
                begin
                  next_state = `COUNT_30;
                  count_enable = `ENABLE;
                  select_mode = `MODE_30;
                  init_state = 2'b00;
                end
              2'b11:
                begin
                  next_state = `PAUSE_30;
                  count_enable = `DISABLE;
                  select_mode = `MODE_30;
                  init_state = 2'b00;
                end
              default:
              begin
              next_state = 2'b00;
              count_enable = 1'b0;
              select_mode = 1'b0;
              init_state = 2'b00;
              end
          endcase

        default:
            begin
            next_state = 2'b00;
            count_enable = 1'b0;
            select_mode = 1'b0;
            init_state = 2'b00;
            end
        endcase


    always @(posedge clk or posedge rst)
        if (rst)
            state <= init_state;
        else
            state <= next_state;

    //output to LED
    assign curr_state = state[0];
        
endmodule
