`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/03/18 19:48:32
// Design Name: 
// Module Name: debounce
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module one_pulse( 
    rst, 
    clk, 
    in_trig,
    out_pulse
);
    input clk, rst, in_trig;
    output reg out_pulse;

    reg in_trig_delay;
    wire out_pulse_next;
    
    always @(posedge clk or posedge rst)
        if (rst)
            in_trig_delay <= 1'b0;
        else    
            in_trig_delay <= in_trig;
    
    assign out_pulse_next = in_trig & (~in_trig_delay);

    always @(posedge clk or posedge rst)
        if (rst)
            out_pulse <= 1'b0;
        else
            out_pulse <= out_pulse_next;
endmodule




